//#include "hxlib.h"
#include <math.h>
#include "frysprodukt.h"
#include "frystermo.h"
#include <stdio.h>


tun tunnel;
prod produkt; 
tider simuleringstid;
varme varmestrom;
mot motstand;


void simuler(){
  /*funksjon som kjrer selve simuleringen
    opprettet 15.05.2008 Jon Arve U Engebakken
    sist endret 19.05.2008 Jon Arve U Engebakken*/


  produkt.nodeh = NODERY;
  produkt.nodeb = NODERX;
 
  int feil;
  int i,j; //Iterasjonsvariable
  int steg,hylle;
  int vogn;
  int teller1, teller2, maks; //kontrollvariable i forbindelse med avslutning av simuleringen
  feil = 0;
  
  maks = produkt.antallHOY * produkt.antallVogner;
  initialBeregninger();
  
  steg = 1;

  while(feil==0){
    teller2=0; //Nullstiller teller i fobindelse med kontroll
    steg++; 
  
    simuleringstid.total[steg] = simuleringstid.total[steg-1] + tidsTab[steg];
  
    for(vogn=0; vogn<produkt.antallVogner; vogn++){
      for(hylle=0; hylle<produkt.antallHOY; hylle++){
	simProduktFrys(vogn, hylle, steg);
	feil = 0;
	teller1 = 0;
	for(i=0; i<produkt.nodeh; i++){
	  for(j=0; j<produkt.nodeb; j++){
	    if(temperaturfelt[produkt.antallVogner-1][hylle][steg][i][j]<produkt.simstopp){
	      teller1 =teller1+1;
	    }//slutt if
	  }//Slutt for j
	}//slutt for i
	if(teller1==(produkt.nodeh*produkt.nodeb)){
	  teller2=teller2 +1;
	}

      }//Slutt for hylle      
    }//Slutt for vogn
    if(teller2==maks){//Alle produktene har oppndd nsket temperatur
      feil=1;        //og kontrollvariabelen for while lkken blir
                     //endret slik at simuleringen blir avsluttet
      simuleringstid.omganger=steg; //Antallet steg simuleringen tok blir angitt
    }
  }//Slutt while

 
  tidsOmgjorer(); //Lager tabeller over akkumulert tid for hvert enkelt tidsskritt


}
//Slutt p funksjonen --simuler--


void initialBeregninger(){ 
  
  /* Funksjon for  beregne diverese initialverdier og stoppbetingeleser
     --Opprettet 07.04.2008 Jon Arve U Engebakken
     --Sist endret 07.04.2008 Jon Arve U Engebakken
  */
  double epsilon;

  epsilon=0.1;

  stegGenerator(); //Oppretter tabell over lengden for de enkelte tidsskrittene
  frysNodenettverk(produkt.nodeh, produkt.nodeb, 1); //Lager nodenettverk for produktet
  frysKontrollvolumflater(produkt.nodeh, produkt.nodeb); //Beregner kontrollvolumflatene til kontrollvolumene    
  startVerdier(produkt.starttemp,produkt.antallVogner, produkt.antallHOY); //Setter inn initial temperaturen for produktet inn i temperaturfelttabell
 

  if(produkt.sluttemp<tunnel.temp || produkt.sluttemp==tunnel.temp){//Fastsettelse for slutt temperatur
    produkt.simstopp=tunnel.temp+epsilon;
  }else{
    produkt.simstopp = produkt.sluttemp;
  }//Slutt fastsettelse for slutt temperatur 

  //Finner nodene som kontrollen skal foretas ved

  sentrumX = floor(produkt.nodeb/2);
  sentrumY = floor(produkt.nodeh/2);

  LuftBeregning();

  varmestrom.entalpivarme = varmeUTfraENTALPIdiff();

}//Slutt p funkjonen initalBeregninger

void simProduktFrys( int vogn, int hylle, int flytparameter){

/**----Funksjon for beregning av varmestrom ut av produktet og
-------temperaturfeltet i produktet.
-------Opprettet februar 2008 Jon Arve U Engebakken
-------Sist endret 02.05.2008 Jon Arve U Engebakken
-------Kalles med hvilket tidsskrit man er kommet til-------*/

  double var2;
  double hjelp;

  if(vogn==0){
    if (type==1){

      var2 =simuleringstid.total[flytparameter];
     
      hjelp = 246.1+16.9*exp(-0.00046296*var2)-var2*0.000066666;
      if (hjelp<tunnel.temp){
	hjelp=tunnel.temp;
      }
      tunnel.tunTemp[vogn][hylle][flytparameter]=hjelp;

    }else{
      tunnel.tunTemp[vogn][hylle][flytparameter] = tunnel.temp;
    }
  }//End if vogn

  konvektivt = frysVarmeovergangstall(tunnel.hast[vogn][hylle],tunnel.tunTemp[vogn][hylle][flytparameter]); //Finner det konvektive varmeovergangstallet mellom luft og produkt
  
  frysKonduktivitetsTabeller(vogn,hylle,flytparameter-1); //Finner varmeovergangstallene som skal brukes for den kommende beregningen.
  testfelttunnel(tunnel.tunTemp[vogn][hylle][flytparameter], vogn, hylle, flytparameter); //Legger inn tunneltemperaturen inn i temperaturfeltet

  finnTempFelt(vogn, hylle, flytparameter); //Beregner temperaturfeltet i produktet ved et gitt tidspunkt
  
    VarmestromUT(vogn, hylle, flytparameter); //Beregner varmestmmen ut av produktet
    tunnel.tunTemp[vogn+1][hylle][flytparameter]= EndringTunnelTemp(vogn, hylle, flytparameter);
    

}
/**-----Slutt paa funksjonen simProduktFrys---------------*/


void frysNodenettverk(int nodehoyde, int nodebredde, int typenettverk){

/**---------------------- Funksjon for plassering av noder---------------
----Opprettet 06.02.2008 Jon Arve U Engebakken
----Sist endret: 28.04.2008  Jon Arve U Engebakken
----Funksjon for  plassere nodene i nettverket for oppdeling av produktet
----Kalles med antall noder i nettverket, forst antallet i hoyden, saa 
----antallet i bredden og til slutt type netttverk, uniformt eller ikke. Blir bare brukt uniformt nettverk.
----Returner ingen verdi, men legger nodeplasseringen inn i en global tabell
-------------------------------------------------------------------   */

  double bredde, hoyde, ab, ah; 
  int nb, nh, i, j;
 
  hoyde = produkt.Hoyde;    //produkthoyde
  bredde = produkt.Bredde;   //produktbredde

//Finner plasseringen til nodene 
//Bruker uniformt nettverk

  nb=nodebredde-2;
  nh=nodehoyde-2;
  
  ab=bredde/nb;
  ah=hoyde/nh;

  for(i=0; i<nodebredde; ++i){
    for(j=0; j<nodehoyde; ++j){
      if(i==0){
	nodematriseb[j][i]=0;
      }else if (i==(nodebredde-1)){
	nodematriseb[j][i]=bredde;
      }else{
	nodematriseb[j][i]=ab/2+ab*(i-1);
      }
    }
  }
  for(j=0; j<nodehoyde; ++j){
    for(i=0; i<nodebredde; ++i){
      if(j==0){
	nodematriseh[j][i]=0;
      }else if(j==(nodehoyde-1)){
	nodematriseh[j][i]=hoyde;
      }else{
	nodematriseh[j][i]=ah/2 + ah*(j-1);
      }
    }
  }

}
/**--------Slutt paa funksjonen frysNodenettverk-------*/


void frysKontrollvolumflater(int nodehoyde, int nodebredde){


/** Funksjon for beregning av kontrollvolumflater
----Sist endret: 13.02.2008 Jon Arve U Engebakken
----Funksjon for  beregne kontrollvolumflatene til kontrollvolum----
----Kalles med antall noder i nettverket, forst antall noder i hoyde, saa---
----antall noder i bredden. Returnerer ingen verdi, men legger storrelsen
----paa kontrollvolumflatene inn i en tabell---------------- */


  int i, j;    //Iterasjonsvariable
  

  //Regner ut kontrollvolumflatene i y-retning
  for(i=0; i<nodehoyde; i++){
    if(i==0){
      produkt.flaterY[i] = 0;
    }else if(i==1){
      produkt.flaterY[i] = (nodematriseh[i+1][0]-nodematriseh[i][0])/2 + nodematriseh[i][0];
    }else if(i==(nodehoyde-2)){
      produkt.flaterY[i] = (nodematriseh[i+1][0]-nodematriseh[i][0])+ (nodematriseh[i][0]-nodematriseh[i-1][0])/2;
    }else if(i==(nodehoyde-1)){
      produkt.flaterY[i] = 0;
    }else{
      produkt.flaterY[i] = (nodematriseh[i+1][0]-nodematriseh[i][0])/2 + (nodematriseh[i][0] - nodematriseh[i-1][0])/2;
      
    }
  }

  //Regner ut kontrollvolumflatene i x-retning
 for(j=0; j<nodebredde; j++){
    if(j==0){
      produkt.flaterX [j] = 0;
    }else if (j==1){
      produkt.flaterX[j]= (nodematriseb[0][j+1]- nodematriseb[0][j])/2+ nodematriseb[0][j];
    }else if(j==(nodebredde-2)){
      produkt.flaterX[j] = (nodematriseb[0][j+1] - nodematriseb[0][j])+ (nodematriseb[0][j]- nodematriseb[0][j-1])/2;
    }else if(j==(nodebredde-1)) {
      produkt.flaterX[j] = 0;
    }else{
      produkt.flaterX[j]=(nodematriseb[0][j+1] - nodematriseb[0][j])/2 + (nodematriseb[0][j] - nodematriseb[0][j-1])/2;
     
    }
 }
}/**--------Slutt paa funksjonen frysKontrollvolumflater-------*/

void frysKonduktivitetsTabeller(int vogn, int hylle, int steg){
 

/**-------Funksjon for aa lage tabeller over konduktiviten til kontrollvolumene
----------Opprettet 27.02.2008 Jon Arve U Engebakken
----------Sist endret: 16.05.2008 Jon Arve U Engebakken
----------Funksjonen kalles med det tidsskrittet og nummer p vognen som blir 
          beregnet. Funksjonen setter konduktiviten for de enkelte
----------kontrollvolumflatene inn i tabeller--------------------*/

  int i,j; //Iterasjonsvariabler
  
    //Regner ut konduktiviteten for flatene i x-retning

  for (j=0; j<(produkt.nodeb-1);j++){
    for(i=0; i<(produkt.nodeh); i++){
      if(j==0){
	produkt.konduktivitetX[i][j] = produkt.flaterX[j+1] * (1/(1/konvektivt + motstand.siden));
      }else if (j==produkt.nodeb-2){
	produkt.konduktivitetX[i][j] = produkt.flaterX[j-1] * (1/(1/konvektivt + motstand.siden));
      }else{	
	produkt.konduktivitetX[i][j] = frysKonduktivitet(temperaturfelt[vogn][hylle][steg][i][j],temperaturfelt[vogn][hylle][steg][i][j+1]);
      }
    }
  }
  //Regner ut konduktiviteten for flatene i y-retning 

 for (j=0; j<(produkt.nodeb);j++){
    for(i=0; i<(produkt.nodeh-1); i++){
      if(i==0){
	produkt.konduktivitetY[i][j] = produkt.flaterY[i+1] * (1/(1/konvektivt + motstand.over)); 
      }else if(i==produkt.nodeh-2){
	produkt.konduktivitetY[i][j] = produkt.flaterY[i-1] * (1/(1/konvektivt + motstand.under)); 
      }else{ 
	produkt.konduktivitetY[i][j] = frysKonduktivitet(temperaturfelt[vogn][hylle][steg][i][j],temperaturfelt[vogn][hylle][steg][i+1][j]);
      }
    }
 }
 //Se p iterasjonsvariablene for i og j nr konduktiviteten blir en funksjon av temperaturen


}
/**-------Slutt paa funksjonen frysKonduktivitetsTabeller---------*/


double frysKonduktivitet(double temp1, double temp2){

/**-------Funksjon for beregning av konduktivt varmeovergangstall
----------Sist endret: 31.03.2008 Jon Arve U Engebakken
----------To inn parametere: temperaturene i nodene som grenser opp mot
----------kontrollvolumflaten--------------*/


  double svar;
  double hjelp1, hjelp2;

  // svar= 0.50;//UTTRYKK FOR K bassert p temp1 og temp2
  hjelp1 = KonduktivitetAvTemperatur(temp1);
  hjelp2 = KonduktivitetAvTemperatur(temp2);

  //Bruker harmonisk midling for beregning av konduktivitet p grenseoverflaten
  svar = 2*hjelp1*hjelp2/(hjelp1+hjelp2);
  return svar;
}

/**-------Slutt paa funksjonen frysKonduktivitet----------------*/

void startVerdier(double start, int vogn, int hylle){

/**----Funksjon for aa sette inn startverdier------------
-------Sist endret 25.02.2008 Jon Arve U Engebakken------
-------Kalles med initial temperaturen i produktet------*/


  int i,j,k,l,m;  //Iterasjonsvariable
  double diff;
  diff = 0.0;

  for(l=0; l<vogn; l++){
    for(m=0; m<hylle; m++){
      tunnel.tunTemp[l][m][0] = start; //Setter starttemperaturen i tunnelen lik 
      tunnel.tunTemp[l][m][1] = start; //starttemperaturen i produktet

      for(k=0; k<2; ++k){
	for(i=0; i<produkt.nodeh; i++){
	  for(j=0; j<produkt.nodeb; j++){
	    temperaturfelt[l][m][k][i][j] = start + diff;
	  }
	}
      }
    }
  }
}
/**------Slutt paa funksjonen startVerdier------*/

void finnTempFelt(int vogn, int hylle, int steg){


  /**----Funksjon for aa beregne temperaturfeltet i produktet
------Opprettet februar 2008 Jon Arve U Engebakken
------Sist endret 04.04.2008 Jon Arve U Engebakken
------Kalles med tidsskrittet beregningen blir foretatt for--*/


  int i, j, k, iter; //Iterasjonsvariable
  double feil; //Kontrollvariabel for konvergens
  double epsilon=0.0001; //Maks forskjell mellom ny og gammel temperatur for konvergens
  double koeffA, koeffB; //Sammentrekningskoeffisenter (reduserer lengden paa uttrykkene)
  double test; //Hjelpeparameter

//Finner koeffisentmatrisene som skal sendes til TDMA

  feil = epsilon*10;
  iter=0;
  // while (feil>epsilon && iter<10000){


    //Tdma i x-retning

  
    //Indre rader

      for(i=1; i<produkt.nodeh-1; i++){
	
	for(j=1; j<(produkt.nodeb-1); j++){

	  if(j==1){//node lengst til venstre

	    produkt.C[i][j] = CpAvTemperatur(temperaturfelt[vogn][hylle][steg-1][i][j]); 

	    koeffA = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterX[j],2));
	    koeffB = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterY[i],2));

	    forrigeX[j] = 0;

	    denneX[j] = 1 + koeffA * (produkt.konduktivitetX[i][j] +  produkt.konduktivitetX[i][j-1]);

	    nesteX[j] = -koeffA * produkt.konduktivitetX[i][j];

	    kjentX[j]= (koeffA * (produkt.konduktivitetX[i][j]*(temperaturfelt[vogn][hylle][steg-1][i][j+1]-temperaturfelt[vogn][hylle][steg-1][i][j]) - produkt.konduktivitetX[i][j-1] *(temperaturfelt[vogn][hylle][steg-1][i][j] - temperaturfelt[vogn][hylle][steg-1][i][j-1])) + koeffB * ( produkt.konduktivitetY[i][j]*( temperaturfelt[vogn][hylle][steg-1][i+1][j]- temperaturfelt[vogn][hylle][steg-1][i][j]) - produkt.konduktivitetY[i-1][j]*(temperaturfelt[vogn][hylle][steg-1][i][j]-temperaturfelt[vogn][hylle][steg-1][i-1][j]))) + (temperaturfelt[vogn][hylle][steg-2][i][j] + koeffA * (produkt.konduktivitetX[i][j]*(temperaturfelt[vogn][hylle][steg-2][i][j+1]- temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetX[i][j-1] * (temperaturfelt[vogn][hylle][steg-2][i][j]- temperaturfelt[vogn][hylle][steg-2][i][j-1])) + 2* koeffB * (produkt.konduktivitetY[i][j]* (temperaturfelt[vogn][hylle][steg-2][i+1][j]- temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetY[i-1][j]* (temperaturfelt[vogn][hylle][steg-2][i][j]- temperaturfelt[vogn][hylle][steg-2][i-1][j]))) + koeffA * produkt.konduktivitetX[i][j-1]*temperaturfelt[vogn][hylle][steg][i][j-1];

	  }else if(j==(produkt.nodeb-2)){//node lengst til hoyre

	    produkt.C[i][j] = CpAvTemperatur(temperaturfelt[vogn][hylle][steg-1][i][j]); // C[i][j]=deltaH/(approxT - temperaturfelt[vogn][hylle][steg-2][i][j]);//

	    koeffA = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterX[j],2));
	    koeffB = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterY[i],2));

	    forrigeX[j] = -koeffA * produkt.konduktivitetX[i][j-1];

	    denneX[j] = 1 + koeffA * (produkt.konduktivitetX[i][j] + produkt.konduktivitetX[i][j-1]);

	    nesteX[j] = 0;

	    kjentX[j]= (koeffA * (produkt.konduktivitetX[i][j] *(temperaturfelt[vogn][hylle][steg-1][i][j+1] -temperaturfelt[vogn][hylle][steg-1][i][j]) - produkt.konduktivitetX[i][j-1]*(temperaturfelt[vogn][hylle][steg-1][i][j] - temperaturfelt[vogn][hylle][steg-1][i][j-1])) + koeffB * ( produkt.konduktivitetY[i][j]*( temperaturfelt[vogn][hylle][steg-1][i+1][j]- temperaturfelt[vogn][hylle][steg-1][i][j]) - produkt.konduktivitetY[i-1][j]*(temperaturfelt[vogn][hylle][steg-1][i][j]-temperaturfelt[vogn][hylle][steg-1][i-1][j]))) + (temperaturfelt[vogn][hylle][steg-2][i][j] + koeffA * (produkt.konduktivitetX[i][j] *(temperaturfelt[vogn][hylle][steg-2][i][j+1] - temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetX[i][j-1]* (temperaturfelt[vogn][hylle][steg-2][i][j]- temperaturfelt[vogn][hylle][steg-2][i][j-1])) + 2* koeffB * (produkt.konduktivitetY[i][j]* (temperaturfelt[vogn][hylle][steg-2][i+1][j]- temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetY[i-1][j]* (temperaturfelt[vogn][hylle][steg-2][i][j]- temperaturfelt[vogn][hylle][steg-2][i-1][j]))) + koeffA * produkt.konduktivitetX[i][j] * temperaturfelt[vogn][hylle][steg][i][j+1];

	  }else{//indre noder

	     produkt.C[i][j] = CpAvTemperatur(temperaturfelt[vogn][hylle][steg-1][i][j]); //C[i][j]= deltaH/(approxT - temperaturfelt[vogn][hylle][steg-2][i][j]);//

	    koeffA = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterX[j],2));
	    koeffB = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterY[i],2));

	    forrigeX[j] = -koeffA * produkt.konduktivitetX[i][j-1];

	    denneX[j] = 1 + koeffA * (produkt.konduktivitetX[i][j] + produkt.konduktivitetX[i][j-1]);

	    nesteX[j] =  -koeffA * produkt.konduktivitetX[i][j];

	    kjentX[j]= (koeffA * (produkt.konduktivitetX[i][j]*(temperaturfelt[vogn][hylle][steg-1][i][j+1]-temperaturfelt[vogn][hylle][steg-1][i][j]) - produkt.konduktivitetX[i][j-1]*(temperaturfelt[vogn][hylle][steg-1][i][j] - temperaturfelt[vogn][hylle][steg-1][i][j-1])) + koeffB * ( produkt.konduktivitetY[i][j]*( temperaturfelt[vogn][hylle][steg-1][i+1][j]- temperaturfelt[vogn][hylle][steg-1][i][j]) - produkt.konduktivitetY[i-1][j]*(temperaturfelt[vogn][hylle][steg-1][i][j]-temperaturfelt[vogn][hylle][steg-1][i-1][j]))) + (temperaturfelt[vogn][hylle][steg-2][i][j] + koeffA * (produkt.konduktivitetX[i][j]*(temperaturfelt[vogn][hylle][steg-2][i][j+1]- temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetX[i][j-1]* (temperaturfelt[vogn][hylle][steg-2][i][j]- temperaturfelt[vogn][hylle][steg-2][i][j-1])) + 2* koeffB * (produkt.konduktivitetY[i][j]* (temperaturfelt[vogn][hylle][steg-2][i+1][j]- temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetY[i-1][j]* (temperaturfelt[vogn][hylle][steg-2][i][j]- temperaturfelt[vogn][hylle][steg-2][i-1][j])));
	  }//end if
	}//end for j x-retning

	//TDMA

	for( k=2; k<produkt.nodeb-1; k++){
	  test = forrigeX[k]/denneX[k-1];
	  denneX[k] =denneX[k]- nesteX[k-1]*test; //b(k) = b(k) - c(k-1) * q;
	  kjentX[k]=kjentX[k]-kjentX[k-1]*test; //d(k) = d (k) - d(k-1) * q;
  
	}//  end

	test=kjentX[produkt.nodeb-2]/denneX[produkt.nodeb-2];//  q = d(n)/b(n);
	produkt.regnHor[i][produkt.nodeb-2] = test;//  x(n) = q;

	for(k=produkt.nodeb-3; k>0; k--){  //  for k = n-1 : -1 :1
	  test= (kjentX[k]-nesteX[k]*test)/denneX[k];//	 q=(d(k) - c(k)*q)/b(k);
	  produkt.regnHor[i][k]=test; //     x(k) = q;
	}  //  end


      }//end for i i x-retning


      //TDMA i y-retning

       
      for (j=1; j<(produkt.nodeb-1); j++){

	for (i=1; i<produkt.nodeh-1; i++){

	  if (i==1){//verste node


	    koeffA = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterX[j],2));
	    koeffB = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterY[i],2));

	    forrigeY[i]= 0;

	    denneY[i] = 1 + koeffB * (produkt.konduktivitetY[i][j]+ produkt.konduktivitetY[i-1][j]);
	    nesteY[i] = - koeffB * produkt.konduktivitetY[i][j];

	    kjentY[i] = produkt.regnHor[i][j] - koeffB * (produkt.konduktivitetY[i][j] * (temperaturfelt[vogn][hylle][steg-2][i+1][j]-temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetY[i-1][j] * (temperaturfelt[vogn][hylle][steg-2][i][j]-temperaturfelt[vogn][hylle][steg-2][i-1][j])) + koeffB * produkt.konduktivitetY[i-1][j]*temperaturfelt[vogn][hylle][steg][i-1][j];


	  }else if (i==(produkt.nodeh-2)){//Nederste node


	    koeffA = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterX[j],2));
	    koeffB = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterY[i],2));

	    forrigeY[i]= -(koeffB) * produkt.konduktivitetY[i-1][j];

	    denneY[i] = 1 + koeffB * (produkt.konduktivitetY[i][j] + produkt.konduktivitetY[i-1][j]);
	    nesteY[i] = 0;

	    kjentY[i] = produkt.regnHor[i][j] - koeffB * (produkt.konduktivitetY[i][j] * (temperaturfelt[vogn][hylle][steg-2][i+1][j] -temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetY[i-1][j] * (temperaturfelt[vogn][hylle][steg-2][i][j]-temperaturfelt[vogn][hylle][steg-2][i-1][j])) + koeffB * produkt.konduktivitetY[i][j]*temperaturfelt[vogn][hylle][steg][i+1][j];


	  }else{//Indre noder

	    koeffA = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterX[j],2));
	    koeffB = (2 * tidsTab[steg])/(3 * produkt.C[i][j] * pow(produkt.flaterY[i],2));

	    forrigeY[i]= -(koeffB) * produkt.konduktivitetY[i-1][j];

	    denneY[i] = 1 + koeffB * (produkt.konduktivitetY[i][j]+ produkt.konduktivitetY[i-1][j]);
	    nesteY[i] = - koeffB * produkt.konduktivitetY[i][j];
	  
	    kjentY[i] = produkt.regnHor[i][j] - koeffB * (produkt.konduktivitetY[i][j] * (temperaturfelt[vogn][hylle][steg-2][i+1][j]-temperaturfelt[vogn][hylle][steg-2][i][j]) - produkt.konduktivitetY[i-1][j] * (temperaturfelt[vogn][hylle][steg-2][i][j]-temperaturfelt[vogn][hylle][steg-2][i-1][j]));
	      
	  }//end if
	}//end for i i y-retning
      

    for( k=2; k<produkt.nodeh-1; k++){
	    test = forrigeY[k]/denneY[k-1];
	    denneY[k] =denneY[k]- nesteY[k-1]*test; //b(k) = b(k) - c(k-1) * q;
	    kjentY[k]=kjentY[k]-kjentY[k-1]*test; //d(k) = d (k) - d(k-1) * q;
  
    }//  end

    test=kjentY[produkt.nodeh-2]/denneY[produkt.nodeh-2];//  q = d(n)/b(n);
  produkt.regnVert[produkt.nodeh-2][j] = test;//  x(n) = q;

  for(k=produkt.nodeh-3; k>0; k--){  //  for k = n-1 : -1 :1
    test= (kjentY[k]-nesteY[k]*test)/denneY[k];//	 q=(d(k) - c(k)*q)/b(k);
    produkt.regnVert[k][j]=test; //     x(k) = q;
  }  //  end
      }//end for j i y-retning
  
 for(i=1; i<produkt.nodeh-1; i++){
    for(j=1; j<produkt.nodeb-1; j++){
      temperaturfelt[vogn][hylle][steg][i][j]=produkt.regnVert[i][j];
    }//end for i
  }//end for j
 // printf("Feil: %7.5f Inter: %5i Steg: %5i \n",feil, iter, steg);


  //Korrigering av funnet temperatur
 
 // if (kontrollvar.tempKor==2) {
   for (i=1; i<produkt.nodeh-1; i++){
     for(j=1; j<produkt.nodeb-1; j++){

       temperaturfelt[vogn][hylle][steg][i][j]=TemperaturKorrigering(EntalpiAvTemperatur(temperaturfelt[vogn][hylle][steg-2][i][j])+produkt.C[i][j]*(temperaturfelt[vogn][hylle][steg][i][j] - temperaturfelt[vogn][hylle][steg-2][i][j]));
       testfelt[i][j]=temperaturfelt[vogn][hylle][steg][i][j];
     }//end for j
   }//end for i
   // }//end if kontrollvar.tempkor
 
  //Angir temperaturen p overflaten. Den blir satt lik temperaturen p noden innenfor overflaten.

    for(j=1; j<produkt.nodeb-1; j++){

      testfelt[0][j]= testfelt[1][j];
      testfelt[produkt.nodeh-1][j]= testfelt[produkt.nodeh-2][j];

    }//end for j

  for (i=1; i<produkt.nodeh-1; i++){

    testfelt[i][0]= testfelt[i][1];
    testfelt[i][produkt.nodeb-1]= testfelt[i][produkt.nodeb-2];

  }//end for i
      testfelt[0][0]=(testfelt[0][1] + testfelt[1][0])/2;
      testfelt[0][produkt.nodeb-1]=(testfelt[0][produkt.nodeb-2] + testfelt[1][produkt.nodeb-1])/2;
      testfelt[produkt.nodeh-1][0]=(testfelt[produkt.nodeh-1][1] + testfelt[produkt.nodeh-2][0])/2;
      testfelt[produkt.nodeh-1][produkt.nodeb-1] = (testfelt[produkt.nodeh-1][produkt.nodeb-2] + testfelt[produkt.nodeh-2][produkt.nodeb-1])/2;


}/**----Slutt paa funksjonen finnTempFelt----------------*/


double frysVarmeovergangstall(double hastighet, double temp){

/**---Funksjon for beregning av varmeovergangstallet mellom produkt og luft
------Sist endret 14.02.2008 Jon Arve U Engebakken
------Funksjonen kalles med hastigheten i tunnelen------*/

  double Nu, Pr, Re; //Nusset -, Prandtl -, Reynolds tall
  double konvek; //Konduktivitet for luft


  Pr = CPair(temp)*DVair(temp)/TCair(temp);  
  Re = hastighet * produkt.Lengde / KVair(temp);

  //Nu = 4.5 * pow(Re, 0.28);  //Khatchaturov 1958
  //  Nu = 0.0154 * pow(Re,0.818) * pow(Pr,0.3); //Becker og Fricke 2004
  // Nu =0.664*pow(Re,0.5)*pow(Pr,(1\3)); //Fundamentals of Heat and Mass Transfer, Frank P. Incropera, David P. DeWitt, s394
  Nu =0.03 *pow(Re, 0.818) * pow(Pr, 0.3); //Egen deffinert

  konvek = Nu * TCair(temp) / produkt.Lengde;

   konvek = 25; //Antatt konstant i frste omgang
  return konvek;

}
/**-----Slutt paa funksjonen frysVarmeovergangstall-------*/


void TDMA(void){

  /*------Funkjsjon for aa lose tridiagonal matrisen----
------Sist endret 15.02.2008 Jon Arve U Engebakken------
------Dette funkjsonen er ikke operativ ennaa.-----*/


  //Folgende er hentet fra Matlab skript: 

  //  function x = tdma(a,b,c,d)

  //Solution of a linear system of algebraic
  //equations with a tri.diagonal matrix of coefficients
  //  using the Thomas-algorithm (No pivoting).
  //  Equation no. i :
  //  (8i)*x(i-1) + b(i)*x(i) + c(i)*x(i+1) = d(i), i = 1,..,n
  //where n is the number of equations.

  //Input
  //Vectors may be in either row - or column-form

  //  a(1:n) ..Lower diagonal. a(1) is not used
  //  b(1:n)..Main dioagonal
  //  c(1:n)..Upper diagonal. c(n) is not used
  //  d(1:n)..Right hand side of the system.

  //     Output

  //  x(1:n)..The solution vector

  /*----- Kode---- */


  //  n = length(b);
  //  x = zeros(size(b));

  //  for k =2:n
  //	 q = a(k)/b(k-1);
  //     b(k) = b(k) - c(k-1) * q;
  //     d(k) = d (k) - d(k-1) * q;
  //  end

  //  q = d(n)/b(n);
  //  x(n) = q;

  //  for k = n-1 : -1 :1
  //	 q=(d(k) - c(k)*q)/b(k);
  //     x(k) = q;
  //  end
}
/*------ Slutt p funksjonen TDMA--------*/


void VarmestromUT(int vogn, int hylle, int steg){

/*---Funksjon for beregning av varmestmmen ut av produktet
-----og samlet varmestrm ut av produktet.
-----Opprettet 03.03.2008 Jon Arve U Engebakken 
-----Sist endret 14.05.2008 Jon Arve U Engebakken
-----Kalles med et gitt tidsskritt og vogn. 
-----Legger varmestrmmen for tidskrittet og samlet varemstrm
-----inn i tabeller---*/


  int i, j; //Iterasjonsvariable
  double sum;

  sum=0; 

  i=0; //Varmestrm fra toppen av produktet
  for (j=1; j<produkt.nodeb-1; j++){
    sum = sum + (testfelt[i][j]-tunnel.tunTemp[vogn][hylle][steg]) * (1/(1/konvektivt + motstand.over))* produkt.flaterX[j] * produkt.Lengde;
  }

  i=produkt.nodeh-1; //Varmestrm fra bunnen av produktet
  for (j=1; j<produkt.nodeb-1; j++){
    sum = sum + (testfelt[i][j]-tunnel.tunTemp[vogn][hylle][steg]) * (1/(1/konvektivt + motstand.under))* produkt.flaterX[j] * produkt.Lengde;
  }

  j=0; //Varmestrm fra venstre side av produktet
  for(i=1; i<produkt.nodeh-1; i++){
    sum = sum  + (testfelt[i][j]-tunnel.tunTemp[vogn][hylle][steg])* (1/(1/konvektivt + motstand.siden)) *produkt.flaterY[i] * produkt.Lengde;
}

  j=produkt.nodeb-1; //Varmestrm fra hyre side av produktet
  for(i=1; i<produkt.nodeh-1; i++){
    sum = sum  + (testfelt[i][j]-tunnel.tunTemp[vogn][hylle][steg])* (1/(1/konvektivt + motstand.siden)) *produkt.flaterY[i] * produkt.Lengde;
}

 varmestrom.varmeTab[vogn][hylle][steg] = sum;
  varmestrom.varmeTotalPro[vogn][hylle][steg] = varmestrom.varmeTotalPro[vogn][hylle][steg-1] + sum *tidsTab[steg];


  //  varmestrom.varmeTabVogn[vogn][steg] = sum * produkt.antallPro;
  //  varmestrom.varmeTotalVogn[vogn][steg] = varmestrom.varmeTotalPro[vogn][steg]*produkt.antallPro;

}
/*---Slutt p funksjonen VarmestromUT-----*/

void stegGenerator(void){

  /*--Funksjon for generering av lengden av tidsskrittene
---Sist endret 11.03.2008  Jon Arve U Engebakken
---blir ikke kalt med noen verdi. Oppretter en tabell over tidsskrittene
---som skal brukes i beregningene---*/

  int i; //Iterasjonsvariabel

  tidsTab[0] = 1;
  tidsTab[1] = 1;

  for (i=2; i<TID; i++){

    if(i>350){
      tidsTab[i] = 350;
    }else{
      tidsTab[i] = i-1;
    }//end if 20

  }//end for i 


}//Slutt p funksjonen ---stegGenerator

void tidsOmgjorer(void){

/*--Funkjson for beregning av virkelig tid p simuleringen, med tilhrende
--- omgjring fra sekund til timer, min og sek
---Opprettet 14.03.2008 Jon Arve U Engebakken
---Sist endret 08.04.2008 Jon Arve U Engebakken
---Kalles uten variabler
---Lagrer resultat i globale variable--*/

  int i; //iterasjonsvariable
  int error;
  int var=0;
  double test;

 
  error=0;
  i=0;

  while (error==0){
    i++;
    test=var-3600*i;
    if(test<0) error=1;    
  }

  simuleringstid.Time = i-1;

  var = var-(i-1)*3600;
  error=0;
  i=0;
  while(error==0){
    i++;
    test=var-60*i;
    if(test<0) error=1;
  }
  simuleringstid.Min = i-1;

  var= var-60*(i-1);
  simuleringstid.Sek = var;

}//--Slutt p funksjonen ---tidsOmgjoring----

double varmeUTfraENTALPIdiff(void){

  /*--Funksjonen beregner total varmestrm ut fra produktet med bakgrunn
    i entalpidifferanser
    Opprettet 27.03.2008 av Jon Arve U Engebakken
    Sist endret 16.05.2008 av Jon Arve U Engebakken
    --Funksjonen har ingen inn parametere.
    --Returnerer varmestrm ut fra produket bassert p entalpdiendringer.-*/

  double var1, var2, volum, svar;

  volum = produkt.Hoyde * produkt.Lengde * produkt.Bredde;

  var1 = EntalpiAvTemperatur(produkt.starttemp);
  var2 = EntalpiAvTemperatur(produkt.simstopp);

  svar = (var1-var2) * volum;

  return svar;
}//Slutt p funksjonen --------varmeUTfraENTALPIdiff----

double prosentAvvik(double varme1, double varme2){

  /*--Funksjon for  beregne avviket mellom simulert varmestrm og 
    varmestrm ut fra entalpidifferanser.
    --Opprettet 27.03.2008 av Jon Arve U Engebakken
    --Sist endret 27.03.2008 av Jon Arve U Engebakken
    --Kalles med de respektive varmestrmmene, varmestrmmen bassert 
    p entalpidifferanser s varmestrmmen fra simuleringene.
    --Returner prosentvis avvik mellom de to varmestrmmene bassert p 
    varmestrmmen bassert p entalpidifferanser. -*/

  double svar;

  svar = (varme2/varme1 - 1) * 100;

  return svar;

}// Slutt p funksjonen --prosentAvvik--

double EndringTunnelTemp(int vogn, int hylle, int steg){

  /*--Funksjonen bergner temperaturen inn p produktvognen bassert
    --p varmestrmmen ut fra den foregende produkvognen
    --Opprettet 04.04.2008 av Jon Arve U Engebakkken
    --Sist endret 04.04.2008 Jon Arve U Engebakken
    --Funkjonen kalles med vogn og tidsskritt for vognen som det skal
    --for.
    --Returnerer temperaturen p luften inn p vognen.--*/

  double tempendring;
  double svar;

  tempendring = varmestrom.varmeTab[vogn][hylle][steg] / (tunnel.luftMengde[vogn][hylle] * tunnel.luftCP);

  svar= tunnel.tunTemp[vogn][hylle][steg]+tempendring;

  return svar;


}//Slutt p funksjonen --EndringTunnelTemp---

void LuftBeregning(void){

  /*  Funksjon for bergning av luftmengden som sirkulerer over 
      produktet i lpet av et sekund i [kg/s]
      Opprettet 08.04.2008 Jon Arve U Engebakken
      Sist endret 16.05.2008 Jon Arve U Engebakken 
      Funksjonen henter verdiene den trenger fra globale verdier.
*/
  double ArealTunnel, ArealProdukt, ArealLuft,  ArealLuftProdukt;
  int i,j; //Iterasjonsvariable

  ArealTunnel = tunnel.bredde * tunnel.hoyde;
  ArealProdukt = produkt.Hoyde * produkt.Bredde * produkt.antallPro;
  ArealLuft = ArealTunnel-ArealProdukt;
  ArealLuftProdukt = ArealLuft/produkt.antallPro;
  
  for(i=0; i<produkt.antallHOY; i++){
    for(j=0; j<produkt.antallVogner; j++){
      tunnel.luftMengde[j][i]=tunnel.hast[j][i] * ArealLuftProdukt * tunnel.luftRHO;

    }
  }

  


}//Slutt p funksjonen --LuftBeregning---

void testfelttunnel(double temp, int vogn, int hylle,int steg){

  int i,j;

  i=0;

  for (j=0; j<produkt.nodeb; j++){
    temperaturfelt[vogn][hylle][steg][i][j]=temp;
  }
 i=produkt.nodeh-1;

  for (j=0; j<produkt.nodeb; j++){
    temperaturfelt[vogn][hylle][steg][i][j]=temp;
  }
 
 j=0;

  for (i=0; i<produkt.nodeh; i++){
    temperaturfelt[vogn][hylle][steg][i][j]=temp;
  }

 j=produkt.nodeb-1;

  for (i=0; i<produkt.nodeh; i++){
    temperaturfelt[vogn][hylle][steg][i][j]=temp;
  }
}//Slutt p funksjonen ----testfelttunnel--
