#include <string.h>
#include <stdio.h>
#include "frysprodukt.h"
#include "frystermo.h"
#include "fryssim.h"

//Rutine som kalles fra excel og som kjrer simuleringen
DLLIMPORT 
int frysTunnel(){
  int feil;  
  simuler();
  feil=0;

 return feil;

}//Slutt p funksjonen ---frysTunnel---


//Rutiner for innlegging av verdier til modellen

DLLIMPORT
void frys (const char *id, double verdi, int *feil){
  *feil=0; 
  //char test;
  // test=*id;

  switch(*id){
  case 'A':tunnel.bredde = verdi;
    break;
  case 'B': tunnel.hoyde = verdi;    
    break;
  case 'C': type = verdi;
    break;
  case 'D': tunnel.temp = verdi;
    break;
  case 'E': tunnel.luftRHO = verdi;
    break;
  case 'F': tunnel.luftCP = verdi;
    break;
  case 'H': produkt.Bredde = verdi;
    break;
  case 'I': produkt.Hoyde = verdi;
    break;
  case 'J': produkt.Lengde = verdi;
    break;
  case 'K': produkt.Tetthet = verdi;
    break; 
  case 'L': produkt.starttemp = verdi;
    break;
  case 'M': produkt.sluttemp = verdi;
    break;
  case 'P': motstand.over = verdi;
    break;
  case 'Q': motstand.siden = verdi;
    break;
  case 'R': motstand.under = verdi;
    break;
  default: *feil = -100;
  }
}//Slutt p funksjonen  --frys--

DLLIMPORT
void frysINT(const char *id, int verdi, int *feil){
  *feil = 0;  
  switch(*id){
  case 'G': produkt.antallVogner = verdi;
    break;
  case 'N': produkt.antallPro = verdi;
    break;
  case 'O': produkt.antallHOY = verdi;
    break; 
  default: *feil =-110;
  }



}//Slutt p funksjonen ---frysINT-----


DLLIMPORT
void frysHASTIGHET(const char *id, int i, int j, double verdi, int *feil){
  //Rutine for innlegging av hastighetene for de enkelte produktene 
  //i er vogn nummer og j er hylle nummer, 0 er verste hylle

  *feil=0;
  switch(*id){
    case'C': tunnel.hast[i][j] = verdi;
    break;
  default: *feil= -113; 
  }
}
//Slutt p rutinen ---frysHASTIGHET--



DLLIMPORT
void hentDIV (char *id, int steg, int *verdi, int *feil){

  //steg er en blindparameter for tilfellene B, C og D
  *feil=0; 
  switch(*id){
  case 'A': *verdi = tidsTab[steg];
    break;
  case 'B': *verdi = simuleringstid.Min; 
    break;
  case 'C': *verdi = simuleringstid.Sek;
    break;
  case 'D': *verdi = simuleringstid.omganger;
    break;
  default: *feil = -10;
  }


}//Slutt p funksjonen  --hentTID--

DLLIMPORT
void hentDIV2 (char *id, int steg, long *verdi, int *feil){
  *feil=0; 
  switch(*id){
  case 'E': *verdi = simuleringstid.total[steg];
    break;
  default: *feil = -10;
  }


}//Slutt p funksjonen  --hentTID--


DLLIMPORT
void frysHentVariabelverdi (const char*id, double *verdi, int *feil){

 *feil=0; 
  
 switch(*id){
 case 'A': *verdi = tunnel.bredde;
   break;
 case 'B': *verdi = tunnel.hoyde;
   break;
   // case 'C': *verdi = tunnel.hast;
   // break;
 case 'D': *verdi = tunnel.temp;
   break;
 case 'E': *verdi = tunnel.luftRHO;
   break;
 case 'F': *verdi = tunnel.luftCP;
   break;
 case 'H': *verdi = produkt.Bredde;
   break;
 case 'I': *verdi = produkt.Hoyde;
   break;
 case 'J': *verdi = produkt.Lengde;
   break;
 case 'K': *verdi = produkt.Tetthet;
    break;
 case 'L': *verdi = produkt.starttemp;
   break;
 case 'M': *verdi = produkt.sluttemp;
   break;
 case 'Z': *verdi = varmestrom.entalpivarme;
   break;
 default: *feil=-104;
 }
}//Slutt p funksjonen --frysHentVaariabelverdi--


DLLIMPORT
void frysHentVariabelverdiINT (const char*id, int *verdi, int *feil){

 *feil=0; 

 switch(*id){
 case 'G': *verdi = produkt.antallVogner;
   break;    
 case 'N': *verdi = produkt.antallPro;
   break;
 case 'O': *verdi = produkt.antallHOY;
   break;
   // case 'P': *verdi = produkt.nodeb;
   //break;
 case 'V': *verdi = simuleringstid.omganger;
   break;
 case 'W': *verdi = simuleringstid.Time;
   break;
 case 'X': *verdi = simuleringstid.Min;
   break;
 case 'Y': *verdi = simuleringstid.Sek;
   break;

 default: *feil = -101;
 }
 
}//Slutt p funksjonen --frysHentVaariabelverdi--

DLLIMPORT
void frysHentResultatVogn(const char *id, int vogn, int hylle, int steg, double *verdi, int *feil){ 

  if(vogn>produkt.antallVogner || vogn<0){
    *feil=-102;
    *verdi=0.0;

  }else{
    *feil=0;
 
    switch(*id){
    case 'Q' : *verdi = varmestrom.varmeTab[vogn][hylle][steg];
      break;
    case 'R': *verdi = varmestrom.varmeTotalPro[vogn][hylle][steg];
      break;
    case 'S': *verdi = tunnel.tunTemp[vogn][hylle][steg];
      break;
    case 'T': *verdi = varmestrom.varmeTotalVogn[vogn][steg];
      break;
    case 'U': *verdi = varmestrom.varmeTabVogn[vogn][steg];
      break;
    
    default: *feil = -103;

    }//Slutt switch 
  }//Slutt if
}//Slutt funksjon ---frysHentResultat---


DLLIMPORT
void frysHentTempFelt(const char *id, int vogn, int hylle, int steg, int xret, int yret, double *verdi, int *feil){

  if (!strcmp(id,"TEMP")){
    *verdi = temperaturfelt[vogn][hylle][steg][yret][xret];
    *feil =0;
  }else{ 
    *feil=-112;
  }//End if
}//Slutt p funksjonen --frysHentTempFelt---

