#ifndef FRYSSIM_H
#define FRYSSIM_H


#ifdef __GNUC__
# define DLLIMPORT __declspec (dllexport)
#endif



/*
  Funksjon som gjr beregninger i forbindelse med produktet.
*/

DLLIMPORT
int frysTunnel(void);

/*
  Funksjoner/Rutiner for  legge inn variable i forbindelse med simuleringen.
*/


DLLIMPORT
void frys (const char *id, double verdi, int *feil);

DLLIMPORT
void frysINT(const char *id, int verdi, int *feil);

DLLIMPORT
void frysHASTIGHET(const char *id, int i, int j, double verdi, int *feil);

/*
  Funksjon for  hente ut verdier som er lagt inn i simuleringene.
*/

DLLIMPORT
void hentDIV (char *id, int steg, int *verdi, int *feil);

DLLIMPORT
void hentDIV2 (char *id, int steg, long *verdi, int *feil);

DLLIMPORT
void frysHentVariabelverdi(const char *id, double *verdi, int *feil);

DLLIMPORT
void frysHentVariabelverdiINT(const char *id, int *verdi, int *feil);

/*
  Funksjoner for  hente ut simuleringsresultater.
*/

DLLIMPORT
void frysHentResultatVogn(const char *id, int vogn, int hylle, int steg, double *verdi, int *feil);

DLLIMPORT
void frysHentTempFelt(const char *id, int vogn, int hylle, int steg, int xret, int yret, double *verdi, int *feil);


#endif
